*******************************************************************************
; Custom ROM tables for the half-rate speech codec
*******************************************************************************


	.def	r_hpcoef		       ; Replaces r_hpfcoefs
	.def	r_pqdata
	.def	r_sqrt_tbl
	.def	r_agc_coef
	.def	r_post_emphasis
	.def	r_shiftab
	.def	r_cgsfbest
	.def	r_cgsframe
	.def	r_vecintflt
        .def    r_r0dectble
        .def    r_r0dectblo
	.def	r_cont
        .def    r_cn_new_factor
        .def    r_gs_table
        .def    r_dhf_mask1

;------------------------------------------------------------------------------
; 32-bit values table
;------------------------------------------------------------------------------

	.sect	"hscusrom"
	.align	2
r_gs_table:
        .long   0000011abH                      ; r_gs_table[0][0]
        .long   0000038d2H                      ; r_gs_table[0][1]
        .long   00000773eH                      ; r_gs_table[0][2]
        .long   0000144efH                      ; r_gs_table[0][3]
        .long   000035675H                      ; r_gs_table[0][4]
        .long   0000648c5H                      ; r_gs_table[0][5]
        .long   0000c3d65H                      ; r_gs_table[0][6]
        .long   00017ae17H                      ; r_gs_table[0][7]
        .long   0002a3dbbH                      ; r_gs_table[0][8]
        .long   0005238e7H                      ; r_gs_table[0][9]
        .long   000695c1aH                      ; r_gs_table[0][10]
        .long   000a60d45H                      ; r_gs_table[0][11]
        .long   000e4cc68H                      ; r_gs_table[0][12]
        .long   001c3ba6aH                      ; r_gs_table[0][13]
        .long   0019e3c96H                      ; r_gs_table[0][14]
        .long   002d1fbacH                      ; r_gs_table[0][15]
        .long   0030453ecH                      ; r_gs_table[0][16]
        .long   00549a998H                      ; r_gs_table[0][17]
        .long   005190298H                      ; r_gs_table[0][18]
        .long   008258920H                      ; r_gs_table[0][19]
        .long   008daff30H                      ; r_gs_table[0][20]
        .long   00c3150e0H                      ; r_gs_table[0][21]
        .long   00e45d850H                      ; r_gs_table[0][22]
        .long   014c111a0H                      ; r_gs_table[0][23]
        .long   00ff7e1c0H                      ; r_gs_table[0][24]
        .long   018a06860H                      ; r_gs_table[0][25]
        .long   013810400H                      ; r_gs_table[0][26]
        .long   01abc9ee0H                      ; r_gs_table[0][27]
        .long   028500940H                      ; r_gs_table[0][28]
        .long   041f22800H                      ; r_gs_table[0][29]
        .long   022fc5040H                      ; r_gs_table[0][30]
        .long   02cd90180H                      ; r_gs_table[0][31]
        .long   000003edeH                      ; r_gs_table[1][0]
        .long   000021fc9H                      ; r_gs_table[1][1]
        .long   00013f0c3H                      ; r_gs_table[1][2]
        .long   0003a7be2H                      ; r_gs_table[1][3]
        .long   0007a6663H                      ; r_gs_table[1][4]
        .long   000fe3773H                      ; r_gs_table[1][5]
        .long   0012fabf4H                      ; r_gs_table[1][6]
        .long   002275cd0H                      ; r_gs_table[1][7]
        .long   001c0ef14H                      ; r_gs_table[1][8]
        .long   002c0b1d8H                      ; r_gs_table[1][9]
        .long   00350fc70H                      ; r_gs_table[1][10]
        .long   005505078H                      ; r_gs_table[1][11]
        .long   004175f30H                      ; r_gs_table[1][12]
        .long   0052c1098H                      ; r_gs_table[1][13]
        .long   008ed3310H                      ; r_gs_table[1][14]
        .long   00a63b470H                      ; r_gs_table[1][15]
        .long   005417870H                      ; r_gs_table[1][16]
        .long   008995ee0H                      ; r_gs_table[1][17]
        .long   007bbe018H                      ; r_gs_table[1][18]
        .long   00a19fa10H                      ; r_gs_table[1][19]
        .long   00b5818c0H                      ; r_gs_table[1][20]
        .long   00fd96ea0H                      ; r_gs_table[1][21]
        .long   00e5cad10H                      ; r_gs_table[1][22]
        .long   013b40d40H                      ; r_gs_table[1][23]
        .long   012d45840H                      ; r_gs_table[1][24]
        .long   014577320H                      ; r_gs_table[1][25]
        .long   02b2e5e00H                      ; r_gs_table[1][26]
        .long   0333e9640H                      ; r_gs_table[1][27]
        .long   0194c35c0H                      ; r_gs_table[1][28]
        .long   01c30f8c0H                      ; r_gs_table[1][29]
        .long   02d16db00H                      ; r_gs_table[1][30]
        .long   02cc970ffH                      ; r_gs_table[1][31]
        .long   0002f18e7H                      ; r_gs_table[2][0]
        .long   000a47be0H                      ; r_gs_table[2][1]
        .long   001222efeH                      ; r_gs_table[2][2]
        .long   001c42df8H                      ; r_gs_table[2][3]
        .long   0024be794H                      ; r_gs_table[2][4]
        .long   003424c40H                      ; r_gs_table[2][5]
        .long   0036950fcH                      ; r_gs_table[2][6]
        .long   004973108H                      ; r_gs_table[2][7]
        .long   0038405b4H                      ; r_gs_table[2][8]
        .long   005d8c8f0H                      ; r_gs_table[2][9]
        .long   005063e08H                      ; r_gs_table[2][10]
        .long   0070cdea0H                      ; r_gs_table[2][11]
        .long   005812be8H                      ; r_gs_table[2][12]
        .long   006da5fc8H                      ; r_gs_table[2][13]
        .long   0088fcd60H                      ; r_gs_table[2][14]
        .long   00a013cb0H                      ; r_gs_table[2][15]
        .long   00909a460H                      ; r_gs_table[2][16]
        .long   009e6cf40H                      ; r_gs_table[2][17]
        .long   00ee581d0H                      ; r_gs_table[2][18]
        .long   00ec99f20H                      ; r_gs_table[2][19]
        .long   00b4e7470H                      ; r_gs_table[2][20]
        .long   00c730e80H                      ; r_gs_table[2][21]
        .long   00ff39d20H                      ; r_gs_table[2][22]
        .long   0105d0d80H                      ; r_gs_table[2][23]
        .long   0158b0b00H                      ; r_gs_table[2][24]
        .long   0172babe0H                      ; r_gs_table[2][25]
        .long   014576460H                      ; r_gs_table[2][26]
        .long   0181a6720H                      ; r_gs_table[2][27]
        .long   026126e80H                      ; r_gs_table[2][28]
        .long   01f590180H                      ; r_gs_table[2][29]
        .long   01fdaad60H                      ; r_gs_table[2][30]
        .long   02e0e8000H                      ; r_gs_table[2][31]
        .long   000c7f603H                      ; r_gs_table[3][0]
        .long   001260cdaH                      ; r_gs_table[3][1]
        .long   001b3926aH                      ; r_gs_table[3][2]
        .long   0026d82bcH                      ; r_gs_table[3][3]
        .long   00228fba0H                      ; r_gs_table[3][4]
        .long   0036ec5b0H                      ; r_gs_table[3][5]
        .long   0034bf4ccH                      ; r_gs_table[3][6]
        .long   0043a55d0H                      ; r_gs_table[3][7]
        .long   0044f9c20H                      ; r_gs_table[3][8]
        .long   005c66f50H                      ; r_gs_table[3][9]
        .long   00515f890H                      ; r_gs_table[3][10]
        .long   006065300H                      ; r_gs_table[3][11]
        .long   00665dc00H                      ; r_gs_table[3][12]
        .long   00802b630H                      ; r_gs_table[3][13]
        .long   00737a1c0H                      ; r_gs_table[3][14]
        .long   0087294e0H                      ; r_gs_table[3][15]
        .long   009253fc0H                      ; r_gs_table[3][16]
        .long   00a619760H                      ; r_gs_table[3][17]
        .long   0097bd060H                      ; r_gs_table[3][18]
        .long   00a6d4e50H                      ; r_gs_table[3][19]
        .long   00d19e520H                      ; r_gs_table[3][20]
        .long   00e15c420H                      ; r_gs_table[3][21]
        .long   00c4e4eb0H                      ; r_gs_table[3][22]
        .long   00e8880e0H                      ; r_gs_table[3][23]
        .long   011cdf480H                      ; r_gs_table[3][24]
        .long   012c85800H                      ; r_gs_table[3][25]
        .long   010f4c0a0H                      ; r_gs_table[3][26]
        .long   013e51b00H                      ; r_gs_table[3][27]
        .long   0189dbaa0H                      ; r_gs_table[3][28]
        .long   018a6bb60H                      ; r_gs_table[3][29]
        .long   022e31500H                      ; r_gs_table[3][30]
        .long   021615240H                      ; r_gs_table[3][31]



;------------------------------------------------------------------------------
; contains constant tables for FILT part.
;------------------------------------------------------------------------------

r_hpcoef .word -14071,30347,-21954,10979,10979
         .word -15385,31632,-21936,10979,10979




;------------------------------------------------------------------------------
;Custom table for submodule 2, aflat
;------------------------------------------------------------------------------

	.ref	r_preq1
	.ref	r_preq2
	.ref	r_preq3
	.ref	r_quant1
	.ref	r_quant2
	.ref	r_quant3

r_pqdata .word	r_preq1 			; address of the prequant table
	.word	64				; number of prequant vectors
	.word	0				; indicates 3 coeffs
	.word	3				; number of coeffs
	.word	r_quant1			; address of quant table
	.word	32				; number of quant vectors
	.word	0
	.word	3				; number of coeffs per vector
	.word	r_preq2
	.word	32
	.word	0
	.word	3
	.word	r_quant2
	.word	16
	.word	0
	.word	3
	.word	r_preq3
	.word	16
	.word	1				; indicates 4 coeffs
	.word	4
	.word	r_quant3
	.word	16
	.word	1
	.word	4

;------------------------------------------------------------------------------
;Table of constants used by sqroot function,lpciir/lpcfir, and spectral_post_
; filt routines
;------------------------------------------------------------------------------

r_sqrt_tbl:
                .word   04000h
                .word   08000h
                .word   20480           ;0.625*32768
                .word   28672           ;0.875*32768

;------------------------------------------------------------------------------

r_agc_coef:     .word   019ah           ;K_AGC_COEF

;------------------------------------------------------------------------------

r_post_emphasis .word   0199ah


;------------------------------------------------------------------------------
; contains custom constant tables for openloop part.
;------------------------------------------------------------------------------


r_shiftab .word 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	  .word 0, 2, 2, 2, 3, 3, 4, 5, 5, 6, 6, 7, 8, 8


;------------------------------------------------------------------------------
r_cgsfbest .word  3
	.word	123
	.word	131
	.word	83
	.word	259
	.word	43
	.word	387
	.word	3

;-------------------------------------------------------------------------------
r_cgsframe .word 0
	.word	120
	.word	128
	.word	80
	.word	256
	.word	40
	.word	384
	.word	0



;------------------------------------------------------------------------------
; Custom ROM tables used in submodule 5, sfrm
;------------------------------------------------------------------------------

; Interpolation filter used pitch

r_vecintflt
        .word 0,-368, 762, -1186, 1515, 31144, 1515, -1186, 762, -368
        .word 183, -681, 1595, -3195, 7239, 29814, -2696, 611, -38, -67
        .word 249, -897, 2214, -4898, 13835, 26040, -5089, 1842, -622, 149
        .word 251, -904, 2360, -5708, 20424, 20424, -5708, 2360, -904, 251
        .word 149, -622, 1842, -5089, 26040, 13835, -4898, 2214, -897, 249
        .word -67, -38, 611, -2696, 29814, 7239, -3195, 1595, -681, 183


;------------------------------------------------------------------------------
; Custom tables replacing r_r0dectbl
;------------------------------------------------------------------------------


r_r0dectble
	.field	6,16		; r_r0dectbl[0] @ 0
	.field	8,16		; r_r0dectbl[2] @ 32
	.field	10,16		; r_r0dectbl[4] @ 64
	.field	13,16		; r_r0dectbl[6] @ 96
	.field	16,16		; r_r0dectbl[8] @ 128
	.field	21,16		; r_r0dectbl[10] @ 160
	.field	26,16		; r_r0dectbl[12] @ 192
	.field	33,16		; r_r0dectbl[14] @ 224
	.field	41,16		; r_r0dectbl[16] @ 256
	.field	52,16		; r_r0dectbl[18] @ 288
	.field	65,16		; r_r0dectbl[20] @ 320
	.field	82,16		; r_r0dectbl[22] @ 352
	.field	103,16		; r_r0dectbl[24] @ 384
	.field	130,16		; r_r0dectbl[26] @ 416
	.field	163,16		; r_r0dectbl[28] @ 448
	.field	205,16		; r_r0dectbl[30] @ 480
	.field	258,16		; r_r0dectbl[32] @ 512
	.field	325,16		; r_r0dectbl[34] @ 544
	.field	410,16		; r_r0dectbl[36] @ 576
	.field	516,16		; r_r0dectbl[38] @ 608
	.field	649,16		; r_r0dectbl[40] @ 640
	.field	817,16		; r_r0dectbl[42] @ 672
	.field	1029,16 	; r_r0dectbl[44] @ 704
	.field	1295,16 	; r_r0dectbl[46] @ 736
	.field	1631,16 	; r_r0dectbl[48] @ 768
	.field	2053,16 	; r_r0dectbl[50] @ 800
	.field	2584,16 	; r_r0dectbl[52] @ 832
	.field	3254,16 	; r_r0dectbl[54] @ 864
	.field	4096,16 	; r_r0dectbl[56] @ 896
	.field	5157,16 	; r_r0dectbl[58] @ 928
	.field	6492,16 	; r_r0dectbl[60] @ 960
	.field	8173,16 	; r_r0dectbl[62] @ 992

;------------------------------------------------------------------------------

r_r0dectblo
	.field	7,16		; r_r0dectbl[1] @ 16
	.field	9,16		; r_r0dectbl[3] @ 48
	.field	12,16		; r_r0dectbl[5] @ 80
	.field	15,16		; r_r0dectbl[7] @ 112
	.field	18,16		; r_r0dectbl[9] @ 144
	.field	23,16		; r_r0dectbl[11] @ 176
	.field	29,16		; r_r0dectbl[13] @ 208
	.field	37,16		; r_r0dectbl[15] @ 240
	.field	46,16		; r_r0dectbl[17] @ 272
	.field	58,16		; r_r0dectbl[19] @ 304
	.field	73,16		; r_r0dectbl[21] @ 336
	.field	92,16		; r_r0dectbl[23] @ 368
	.field	115,16		; r_r0dectbl[25] @ 400
	.field	145,16		; r_r0dectbl[27] @ 432
	.field	183,16		; r_r0dectbl[29] @ 464
	.field	230,16		; r_r0dectbl[31] @ 496
	.field	290,16		; r_r0dectbl[33] @ 528
	.field	365,16		; r_r0dectbl[35] @ 560
	.field	460,16		; r_r0dectbl[37] @ 592
	.field	579,16		; r_r0dectbl[39] @ 624
	.field	728,16		; r_r0dectbl[41] @ 656
	.field	917,16		; r_r0dectbl[43] @ 688
	.field	1154,16 	; r_r0dectbl[45] @ 720
	.field	1453,16 	; r_r0dectbl[47] @ 752
	.field	1830,16 	; r_r0dectbl[49] @ 784
	.field	2303,16 	; r_r0dectbl[51] @ 816
	.field	2900,16 	; r_r0dectbl[53] @ 848
	.field	3651,16 	; r_r0dectbl[55] @ 880
	.field	4596,16 	; r_r0dectbl[57] @ 912
	.field	5786,16 	; r_r0dectbl[59] @ 944
	.field	7284,16 	; r_r0dectbl[61] @ 976

;------------------------------------------------------------------------------
; Custom table merging r_oldcont and r_newcont
;------------------------------------------------------------------------------

r_cont:
	.field	9830,16 	; r_newcont[0] @ 0
        .field  22938,16        ; r_oldcont[0] @ 0
	.field	20316,16	; r_newcont[1] @ 16
        .field  12452,16        ; r_oldcont[1] @ 16
	.field	30147,16	; r_newcont[2] @ 32
        .field  2621,16         ; r_oldcont[2] @ 32
	.field	32767,16	; r_newcont[3] @ 48
        .field  0,16            ; r_oldcont[3] @ 48

;------------------------------------------------------------------------------
; Custom tables used for VAD, DTX, homing ...
;------------------------------------------------------------------------------



r_cn_new_factor:
        .word   00aaaH                          ; r_cn_new_factor[0]
        .word   01554H                          ; r_cn_new_factor[1]
        .word   01ffeH                          ; r_cn_new_factor[2]
        .word   02aa8H                          ; r_cn_new_factor[3]
        .word   03552H                          ; r_cn_new_factor[4]
        .word   03ffcH                          ; r_cn_new_factor[5]
        .word   04aa6H                          ; r_cn_new_factor[6]
        .word   05550H                          ; r_cn_new_factor[7]
        .word   05ffaH                          ; r_cn_new_factor[8]
        .word   06aa4H                          ; r_cn_new_factor[9]
        .word   0754eH                          ; r_cn_new_factor[10]
        .word   07fffH                          ; r_cn_new_factor[11]


r_dhf_mask1:

    .word  0x0000                             ;/* R0      */
    .word  0x0371                             ;/* LPC1    */
    .word  0x015E                             ;/* LPC2    */
    .word  0x00c3                             ;/* LPC3    */
    .word  0x0001                             ;/* INT_LPC */
    .word  0x0000                             ;/* MODE    */
    .word  0x0047                             ;/* CODE1_1 */
    .word  0x004a                             ;/* CODE2_1 */
    .word  0x0000                             ;/* GSP0_1  */
    .word  0x0009                             ;/* CODE1_2 */
    .word  0x0026                             ;/* CODE2_2 */
    .word  0x0007                             ;/* GSP0_2  */
    .word  0x0000                             ;/* CODE1_3 */
    .word  0x0000                             ;/* CODE2_3 */
    .word  0x0000                             ;/* GSP0_3  */
    .word  0x0000                             ;/* CODE1_4 */
    .word  0x0000                             ;/* CODE2_4 */
    .word  0x0000                             ;/* GSP0_4  */


        .end

