;
; file: INIT-FFT.ASM --> same for all 320C5xx RADIX 2 complex FFTs
;
; Update:21.4.94 / Vers.: 0.90 / Manfred Christ / Texas Instruments - Freising
;
         .mmregs
;
         .include C5xXRAD2.ASM
;
         .def    N,TWIDLEN,FFTLEN
         .def    FFT,INPUT,DATA,TWID
;
stacksize .set    80
STACK     .usect  "stack",stacksize
;
         .sect   "twiddles"
TWIDSTRT .include twiddles.q15   ; table of twiddle factors for the FFT
	 .if	 N>1024
	 .include twid2048.q15
	 .endif
TWIDEND  .set    $
TWIDLEN  .set    TWIDEND-TWIDSTRT
;
INPUT    .usect  "input",N*2     ; input data array
TWID     .usect  "twid",1 ;TWIDLEN  ; reserve space for twiddles
DATA     .usect  "fftdata",N*2   ; working data array

;
;  Initialized  variables
;
        .sect "vectors"
;        b     INIT
;
;        .sect "init"
;INIT:   ld    #0,DP           ; DP = Page 0
;        stm   #STACK+stacksize,sp
;        .if   N>4
;        ld    #SIN45,DP
;        .bss  SIN45,1
;        st    #5a82h,SIN45
;        .endif
;
; EXECUTE THE FFT
;
;callfft calld FFT
;  ;;;;  stm   #000010100011110b,ST1   ; ASM=-2 , FRACT=0, sbx=1
;        stm   #000010101011110b,ST1 ; ASM=-2 , FRACT=1, sbx=1
                                    ; shift 1 from Product to A,B
;wait    b     wait           ; stops here after return from subroutine

