;
; file: INIT-FFT2.ASM --> same for all 320C5xx RADIX 2 complex FFTs
;
; Update:21.4.94 / Vers.: 0.90 / Manfred Christ / Texas Instruments - Freising
;
         .mmregs
;
	 .include C5xXRA22.ASM
;
	 .def	 N2,TWIDLEN2,FFTLEN2
	 .def	 FFT2,INPUT2,DATA2,TWID2
;
stacksize .set    80
STACK     .usect  "stack",stacksize
;
	 .sect	 "twiddle2"
TWIDSTRT2 .include twiddle2.q15   ; table of twiddle factors for the FFT
	 .if	 N2>1024
	 .include twid2048.q15
	 .endif
TWIDEND2 .set	 $
TWIDLEN2 .set	 TWIDEND2-TWIDSTRT2
;
INPUT2	 .usect  "input2",N2*2     ; input data array
TWID2	 .usect  "twid2",1 ;TWIDLEN2 ; reserve space for twiddles
DATA2	 .usect  "fftdata2",N2*2   ; working data array

;
;  Initialized  variables
;
        .sect "vectors"
;        b     INIT
;
;        .sect "init"
;INIT:   ld    #0,DP           ; DP = Page 0
;        stm   #STACK+stacksize,sp
;        .if   N>4
;        ld    #SIN45,DP
;        .bss  SIN45,1
;        st    #5a82h,SIN45
;        .endif
;
; EXECUTE THE FFT
;
;callfft calld FFT
;  ;;;;  stm   #000010100011110b,ST1   ; ASM=-2 , FRACT=0, sbx=1
;        stm   #000010101011110b,ST1 ; ASM=-2 , FRACT=1, sbx=1
                                    ; shift 1 from Product to A,B
;wait    b     wait           ; stops here after return from subroutine

